org.icefaces.ace.component.panel

## Class PanelBase

- java.lang.Object
- - javax.faces.component.UIComponent
  - - javax.faces.component.UIComponentBase
    - - javax.faces.component.UIPanel
      - - org.icefaces.ace.component.panel.PanelBase

- All Implemented Interfaces:
    java.util.EventListener, javax.faces.component.behavior.ClientBehaviorHolder, javax.faces.component.PartialStateHolder, javax.faces.component.StateHolder, javax.faces.component.TransientStateHolder, javax.faces.event.ComponentSystemEventListener, javax.faces.event.FacesListener, javax.faces.event.SystemEventListenerHolder, IceClientBehaviorHolder, IPanel
  Direct Known Subclasses:
    Panel

      public abstract class PanelBase
      extends javax.faces.component.UIPanel
      implements IPanel, IceClientBehaviorHolder

  Panel is a generic grouping component that also supports toggling, closing and options menu. Both Close and Toggle events can be listened on server side with ajax listeners.

  For more information, see the Panel Wiki Documentation.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected static class` | `PanelBase.PropertyKeys`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.String` | `COMPONENT_TYPE`
    `static java.lang.String` | `RENDERER_TYPE`

    - ### Fields inherited from class javax.faces.component.UIPanel

      `COMPONENT_FAMILY`

    - ### Fields inherited from class javax.faces.component.UIComponent

      `ATTRS_WITH_DECLARED_DEFAULT_VALUES, BEANINFO_KEY, bindings, COMPOSITE_COMPONENT_TYPE_KEY, COMPOSITE_FACET_NAME, CURRENT_COMPONENT, CURRENT_COMPOSITE_COMPONENT, FACETS_KEY, HONOR_CURRENT_COMPONENT_ATTRIBUTES_PARAM_NAME, VIEW_LOCATION_KEY`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PanelBase()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addClientBehavior(java.lang.String eventName, javax.faces.component.behavior.ClientBehavior behavior)`
    `int` | `getCloseSpeed()` Return the value of the `closeSpeed` property.
    `java.lang.String` | `getDefaultEventName()`
    `java.lang.String` | `getDefaultExecute(java.lang.String event)`
    `java.lang.String` | `getDefaultRender(java.lang.String event)`
    `java.util.Collection<java.lang.String>` | `getEventNames()`
    `java.lang.String` | `getFamily()`
    `java.lang.String` | `getFooter()` Return the value of the `footer` property.
    `java.lang.String` | `getHeader()` Return the value of the `header` property.
    `java.lang.String` | `getListenerArgument(java.lang.String event)`
    `java.lang.String` | `getStyle()` Return the value of the `style` property.
    `java.lang.String` | `getStyleClass()` Return the value of the `styleClass` property.
    `int` | `getToggleSpeed()` Return the value of the `toggleSpeed` property.
    `java.lang.String` | `getWidgetVar()` Return the value of the `widgetVar` property.
    `boolean` | `isClosable()` Return the value of the `closable` property.
    `boolean` | `isCollapsed()` Return the value of the `collapsed` property.
    `boolean` | `isDisableInputs()` Return the value of the `disableInputs` property.
    `java.lang.Boolean` | `isPreviousDisableInputs()` Return the value of the `previousDisableInputs` property.
    `protected boolean` | `isPropertySet(java.lang.String finder)`
    `boolean` | `isToggleable()` Return the value of the `toggleable` property.
    `boolean` | `isVisible()` Return the value of the `visible` property.
    `void` | `setClosable(boolean closable)` Set the value of the `closable` property.
    `void` | `setCloseSpeed(int closeSpeed)` Set the value of the `closeSpeed` property.
    `void` | `setCollapsed(boolean collapsed)` Set the value of the `collapsed` property.
    `void` | `setDisableInputs(boolean disableInputs)` Set the value of the `disableInputs` property.
    `void` | `setFooter(java.lang.String footer)` Set the value of the `footer` property.
    `void` | `setHeader(java.lang.String header)` Set the value of the `header` property.
    `void` | `setPreviousDisableInputs(java.lang.Boolean previousDisableInputs)` Set the value of the `previousDisableInputs` property.
    `void` | `setStyle(java.lang.String style)` Set the value of the `style` property.
    `void` | `setStyleClass(java.lang.String styleClass)` Set the value of the `styleClass` property.
    `void` | `setToggleable(boolean toggleable)` Set the value of the `toggleable` property.
    `void` | `setToggleSpeed(int toggleSpeed)` Set the value of the `toggleSpeed` property.
    `void` | `setValueExpression(java.lang.String name, javax.el.ValueExpression binding)`
    `void` | `setVisible(boolean visible)` Set the value of the `visible` property.
    `void` | `setWidgetVar(java.lang.String widgetVar)` Set the value of the `widgetVar` property.

    - ### Methods inherited from class javax.faces.component.UIComponentBase

      `addFacesListener, broadcast, clearInitialState, decode, encodeBegin, encodeChildren, encodeEnd, findComponent, getAttributes, getChildCount, getChildren, getClientBehaviors, getClientId, getFacesContext, getFacesListeners, getFacet, getFacetCount, getFacets, getFacetsAndChildren, getId, getListenersForEventClass, getParent, getRenderer, getRendererType, getRendersChildren, getValueBinding, invokeOnComponent, isRendered, isTransient, markInitialState, processDecodes, processRestoreState, processSaveState, processUpdates, processValidators, queueEvent, removeFacesListener, restoreAttachedState, restoreState, saveAttachedState, saveState, setId, setParent, setRendered, setRendererType, setTransient, setValueBinding, subscribeToEvent, unsubscribeFromEvent`

    - ### Methods inherited from class javax.faces.component.UIComponent

      `encodeAll, getClientId, getCompositeComponentParent, getContainerClientId, getCurrentComponent, getCurrentCompositeComponent, getNamingContainer, getResourceBundleMap, getStateHelper, getStateHelper, getTransientStateHelper, getTransientStateHelper, getValueExpression, initialStateMarked, isCompositeComponent, isInView, isVisitable, popComponentFromEL, processEvent, pushComponentToEL, restoreTransientState, saveTransientState, setInView, visitTree`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface javax.faces.component.behavior.ClientBehaviorHolder

      `getClientBehaviors`

- - ### Field Detail

    - #### COMPONENT_TYPE

          public static final java.lang.String COMPONENT_TYPE

      See Also:
        Constant Field Values

    - #### RENDERER_TYPE

          public static final java.lang.String RENDERER_TYPE

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### PanelBase

          public PanelBase()

  - ### Method Detail

    - #### getFamily

          public java.lang.String getFamily()

      Overrides:
        `getFamily` in class `javax.faces.component.UIPanel`

    - #### setClosable

          public void setClosable(boolean closable)

      Set the value of the `closable` property.

      Contents: Boolean value that specifies whether the panel has a close button.

      Specified by:
        `setClosable` in interface `IPanel`

    - #### isClosable

          public boolean isClosable()

      Return the value of the `closable` property.

      Contents: Boolean value that specifies whether the panel has a close button. Default = 'false'.

      Specified by:
        `isClosable` in interface `IPanel`

    - #### setCloseSpeed

          public void setCloseSpeed(int closeSpeed)

      Set the value of the `closeSpeed` property.

      Contents: Integer value that specifies the duration of the closing animation.

      Specified by:
        `setCloseSpeed` in interface `IPanel`

    - #### getCloseSpeed

          public int getCloseSpeed()

      Return the value of the `closeSpeed` property.

      Contents: Integer value that specifies the duration of the closing animation. Default = '1000'.

      Specified by:
        `getCloseSpeed` in interface `IPanel`

    - #### setCollapsed

          public void setCollapsed(boolean collapsed)

      Set the value of the `collapsed` property.

      Contents: Boolean value that specifies whether the panel is collapsed.

      Specified by:
        `setCollapsed` in interface `IPanel`

    - #### isCollapsed

          public boolean isCollapsed()

      Return the value of the `collapsed` property.

      Contents: Boolean value that specifies whether the panel is collapsed. Default = 'false'.

      Specified by:
        `isCollapsed` in interface `IPanel`

    - #### setDisableInputs

          public void setDisableInputs(boolean disableInputs)

      Set the value of the `disableInputs` property.

      Contents: Boolean value that specifies whether all input elements inside this panel should be disabled or not. This doesn't affect the children components' internal state; this simply disables all input elements in the client side, in order to avoid submitting their values in requests to the server. (Note: some components might not look different to the user when disabled via this option, but their values will not be submitted to the server nonetheless.)

      Specified by:
        `setDisableInputs` in interface `IPanel`

    - #### isDisableInputs

          public boolean isDisableInputs()

      Return the value of the `disableInputs` property.

      Contents: Boolean value that specifies whether all input elements inside this panel should be disabled or not. This doesn't affect the children components' internal state; this simply disables all input elements in the client side, in order to avoid submitting their values in requests to the server. (Note: some components might not look different to the user when disabled via this option, but their values will not be submitted to the server nonetheless.) Default = 'false'.

      Specified by:
        `isDisableInputs` in interface `IPanel`

    - #### setFooter

          public void setFooter(java.lang.String footer)

      Set the value of the `footer` property.

      Contents: Footer text of the panel.

      Specified by:
        `setFooter` in interface `IPanel`

    - #### getFooter

          public java.lang.String getFooter()

      Return the value of the `footer` property.

      Contents: Footer text of the panel.

      Specified by:
        `getFooter` in interface `IPanel`

    - #### setHeader

          public void setHeader(java.lang.String header)

      Set the value of the `header` property.

      Contents: Header text of the panel.

      Specified by:
        `setHeader` in interface `IPanel`

    - #### getHeader

          public java.lang.String getHeader()

      Return the value of the `header` property.

      Contents: Header text of the panel.

      Specified by:
        `getHeader` in interface `IPanel`

    - #### setStyle

          public void setStyle(java.lang.String style)

      Set the value of the `style` property.

      Contents: Style to apply to the container element.

      Specified by:
        `setStyle` in interface `IPanel`

    - #### getStyle

          public java.lang.String getStyle()

      Return the value of the `style` property.

      Contents: Style to apply to the container element.

      Specified by:
        `getStyle` in interface `IPanel`

    - #### setStyleClass

          public void setStyleClass(java.lang.String styleClass)

      Set the value of the `styleClass` property.

      Contents: Style class to apply to the container element.

      Specified by:
        `setStyleClass` in interface `IPanel`

    - #### getStyleClass

          public java.lang.String getStyleClass()

      Return the value of the `styleClass` property.

      Contents: Style class to apply to the container element.

      Specified by:
        `getStyleClass` in interface `IPanel`

    - #### setToggleSpeed

          public void setToggleSpeed(int toggleSpeed)

      Set the value of the `toggleSpeed` property.

      Contents: Integer value that specifies the duration of the transition between states.

      Specified by:
        `setToggleSpeed` in interface `IPanel`

    - #### getToggleSpeed

          public int getToggleSpeed()

      Return the value of the `toggleSpeed` property.

      Contents: Integer value that specifies the duration of the transition between states. Default = '1000'.

      Specified by:
        `getToggleSpeed` in interface `IPanel`

    - #### setToggleable

          public void setToggleable(boolean toggleable)

      Set the value of the `toggleable` property.

      Contents: Boolean value that specifies whether to display a button to toggle between the expanded and collapsed states of the panel.

      Specified by:
        `setToggleable` in interface `IPanel`

    - #### isToggleable

          public boolean isToggleable()

      Return the value of the `toggleable` property.

      Contents: Boolean value that specifies whether to display a button to toggle between the expanded and collapsed states of the panel. Default = 'false'.

      Specified by:
        `isToggleable` in interface `IPanel`

    - #### setVisible

          public void setVisible(boolean visible)

      Set the value of the `visible` property.

      Contents: Boolean value that specifies whether the panel is visible.

      Specified by:
        `setVisible` in interface `IPanel`

    - #### isVisible

          public boolean isVisible()

      Return the value of the `visible` property.

      Contents: Boolean value that specifies whether the panel is visible. Default = 'true'.

      Specified by:
        `isVisible` in interface `IPanel`

    - #### setWidgetVar

          public void setWidgetVar(java.lang.String widgetVar)

      Set the value of the `widgetVar` property.

      Contents: Name of the widget variable to access the client side api.

      Specified by:
        `setWidgetVar` in interface `IPanel`

    - #### getWidgetVar

          public java.lang.String getWidgetVar()

      Return the value of the `widgetVar` property.

      Contents: Name of the widget variable to access the client side api.

      Specified by:
        `getWidgetVar` in interface `IPanel`

    - #### setPreviousDisableInputs

          public void setPreviousDisableInputs(java.lang.Boolean previousDisableInputs)

      Set the value of the `previousDisableInputs` property.

      Specified by:
        `setPreviousDisableInputs` in interface `IPanel`

    - #### isPreviousDisableInputs

          public java.lang.Boolean isPreviousDisableInputs()

      Return the value of the `previousDisableInputs` property.

      Specified by:
        `isPreviousDisableInputs` in interface `IPanel`

    - #### isPropertySet

          protected boolean isPropertySet(java.lang.String finder)

    - #### setValueExpression

          public void setValueExpression(java.lang.String name,
                                         javax.el.ValueExpression binding)

      Overrides:
        `setValueExpression` in class `javax.faces.component.UIComponent`

    - #### getEventNames

          public java.util.Collection<java.lang.String> getEventNames()

      Specified by:
        `getEventNames` in interface `javax.faces.component.behavior.ClientBehaviorHolder`
      Overrides:
        `getEventNames` in class `javax.faces.component.UIComponentBase`

    - #### getDefaultEventName

          public java.lang.String getDefaultEventName()

      Specified by:
        `getDefaultEventName` in interface `javax.faces.component.behavior.ClientBehaviorHolder`
      Overrides:
        `getDefaultEventName` in class `javax.faces.component.UIComponentBase`

    - #### getDefaultRender

          public java.lang.String getDefaultRender(java.lang.String event)

      Specified by:
        `getDefaultRender` in interface `IceClientBehaviorHolder`

    - #### getDefaultExecute

          public java.lang.String getDefaultExecute(java.lang.String event)

      Specified by:
        `getDefaultExecute` in interface `IceClientBehaviorHolder`

    - #### getListenerArgument

          public java.lang.String getListenerArgument(java.lang.String event)

      Specified by:
        `getListenerArgument` in interface `IceClientBehaviorHolder`

    - #### addClientBehavior

          public void addClientBehavior(java.lang.String eventName,
                                        javax.faces.component.behavior.ClientBehavior behavior)

      Specified by:
        `addClientBehavior` in interface `javax.faces.component.behavior.ClientBehaviorHolder`
      Overrides:
        `addClientBehavior` in class `javax.faces.component.UIComponentBase`

Copyright 2025 ICEsoft Technologies Canada, Corp. All Rights Reserved.